import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent.Future
class DataManager {
  var adminOperationCount: Int = 0

  /**
    * Perform admin operations if the user is allowed to perform them
    * @param data  admin data
    * @param securityPolicy the security policy to check users access
    * @param userRole the current users role
    * @return
    */
  def doAdminStuff(
    data: String
  )(
    implicit securityPolicy: SecurityPolicy,
    userRole:                UserRole
  ): Future[Int] =
    securityPolicy.withRole(UserRole.ADMIN) {
      println("Performing admin operation")
      adminOperationCount += 1
      Future(adminOperationCount)
    }

}
