import scala.concurrent.Future
class SecurityPolicy {

  /**
    * Run the specified operation only if the expectedRole is equal to the users role
    * @param expectedRole the required role to execute the operation
    * @param operation the operation to perform
    * @param userRole the users actual role
    * @return the result of the operation or throws an exception if unauthorized
    */
  def withRole(expectedRole: UserRole)(operation: => Future[Int])(implicit userRole: UserRole) =
    if (expectedRole == userRole)
      operation
    else
      throw new Exception(s"must have $expectedRole to perform this operation")
}
